#include <stdio.h>
#define n 4064

char  head[72][80], f1[30];
short ccd[n*48];                    // assume max_file is: 48
float a[n][n];
float gg,rr,ss;
FILE  *fp,*f[48];		
int   imode,ip=0;

main(ac,av)
int ac; char *av[];                        
{
  float fmval,s;
  int i,j,k,n1,n2,ipos;			/* here, int is 4 bytes length */
  float sky1,sky2,sky3,sky4;
  short d[2032*2032];
  if(ac<3)stop("\tUsage:  superbias batch_file outputfile [mode]\0");

  strcpy(f1,av[1]);		/* batch file */
  fp=fopen(f1,"r");
  if(fp==0){ printf("\n\t cannot found batch_file: %s\n",f1); exit(0); }
  for(i=0;i<48;i++){
    ip++;
    fscanf(fp,"%s\n",f1); printf("\t%d:\t%s\n",ip,f1);
    inqh(f1,&n1,&n2);
    if(n1!=n || n2!=n)stop("SIZE not 4064*4064\0");
    f[i]=fopen(f1,"rb"); fread(head,80,72,f[i]);
    if(feof(fp))break;
  }
  fclose(fp);
  if(ip < 4)stop("too less files\0");
  imode=0;
  if(ac>3){
    strcpy(f1,av[3]);
    if(nindex(f1,"med")==0 || nindex(f1,"MED")==0)imode=1;
  } else if(ip > 9)imode=1;
  if(imode == 1)printf("using Median    ");
  if(imode == 0)printf("using Mean      ");
  gg=3.9; rr=12.; ss=3.;

  work(a,ccd);  printf("done\n");
  n2=2032;
  k=0; for(i=0;i<n2;i++)for(j=0;j<n2;j++)d[k++]=a[i][j];  //1
  white_black(d,n2,n2,&sky1,&s);
  printf("1:  %9.2f %9.2f\n",sky1,s);
  k=0; for(i=0;i<n2;i++)for(j=n2;j<n;j++)d[k++]=a[i][j];  //2
  white_black(d,n2,n2,&sky2,&s);
  printf("2:  %9.2f %9.2f\n",sky2,s);
  k=0; for(i=n2;i<n;i++)for(j=0;j<n2;j++)d[k++]=a[i][j];  //3
  white_black(d,n2,n2,&sky3,&s);
  printf("3:  %9.2f %9.2f\n",sky3,s);
  k=0; for(i=n2;i<n;i++)for(j=n2;j<n;j++)d[k++]=a[i][j];  //4
  white_black(d,n2,n2,&sky4,&s);
  printf("4:  %9.2f %9.2f\n",sky4,s);
  k=indexpos(head,"GAIN6   ",72);
  if(k==72)k=indexpos(head,"SKY1    ",72); j=k;
  sprintf(&head[k++][0],"SKY1    = %20.2f /    [1,2032][1,2032]   ",sky1);
  sprintf(&head[k++][0],"SKY2    = %20.2f / [2033,4064][1,2032]   ",sky2);
  sprintf(&head[k++][0],"SKY3    = %20.2f /    [1,2032][2033,4064]",sky3);
  sprintf(&head[k++][0],"SKY4    = %20.2f / [2033,4064][2032,4064]",sky4);
  for(i=0;i<11;i++)head[j+0][55+i]=32;
  for(i=0;i<11;i++)head[j+1][55+i]=32;
  for(i=0;i<11;i++)head[j+2][55+i]=32;
  for(i=0;i<11;i++)head[j+3][55+i]=32;

  strncpy(&head[1][27],"-32",3); /* real*4 */
  strcpy(f1,av[2]);
  i=nindex(f1,".");
  if(i>0)strcpy(&f1[i],".fit");
  else strcat(f1,".fit");
  fmval=(sky1+sky2+sky3+sky4)/4.;
  printf("%s    Mean value: %8.2f\n",f1,fmval);
  ipos=indexpos(head,"GAIN2   ",72);
  for(i=9;i<80;i++)head[ipos][i]=32;
  strncpy(&head[ipos][0],"MEANVAL =",9);
  strncpy(&head[ipos][33],"MEAN VALUE OF BIAS  FIELD",25);
  sprintf(&head[ipos][22],"%8.2f",fmval); head[ipos][30]=32;
  ipos=indexpos(head,"GAIN3   ",72);
  for(i=9;i<80;i++)head[ipos][i]=32;
  strncpy(&head[ipos][11],"SUPER BIAS",10);
  if(imode == 1)strncpy(&head[ipos][21],"_median",7);
  if(imode == 0)strncpy(&head[ipos][21],"_mean  ",7);
  ipos=indexpos(head,"PZERO   ",72);
  if(ipos==72)ipos=indexpos(head,"BZERO   ",72);
  strncpy(&head[ipos][25],"  0.0",5);
  head[ipos][0]='P'; head[ipos+1][0]='P';
  unlink(f1);
  printf("written data:  %s\n",f1);
  fp=fopen(f1,"wb");
  fwrite(head,80,72,fp);
  swap4(a,n*n*4);	
  fwrite(a,4,n*n,fp);
  fclose(fp);
  exit(0);
}

work(a,ccd)
float *a;
short ccd[];
{
  float bb[48];
  float rgs,x;
  int i,j,k,l;
  printf("g= %6.2f   r= %6.2f  nsigma= %6.2f\n",gg,rr,ss);
  for(i=0;i<69;i++)printf("-"); printf("\n");
  rgs=ss*rr/gg;
  for(i=0;i<n;i++){
    if(i%99==0){ printf("."); fflush(stdout); }
    for(j=0;j<ip;j++){
      k=j*n;
      fread(&ccd[k],2,n,f[j]);
    }
    swap2(ccd,n*ip*2);				
    for(j=0;j<n;j++){
      l=j;
      for(k=0;k<ip;k++,l+=n)bb[k]=ccd[l]+32768;
      if(imode == 0)sup_mean(bb,ip,rgs,&x);
      if(imode == 1)sup_median(bb,ip,&x);
      *a++ =x;
    }
  }
  for(j=0;j<ip;j++)fclose(f[j]);
}
	
sup_mean(a,nn,rgs,mean)
float a[],rgs,*mean; 
int nn;
{
  int i,j,m;
  float x;
  for(i=0;i<nn-1;i++)for(j=i+1;j<nn;j++)if(a[i]>a[j]){
    x=a[i]; a[i]=a[j]; a[j]=x;
  }
  j=nn;
l10:
  m=j; i=j/2;
  x= (i+i==j) ? (a[i]+a[i-1])*.5 : a[i];
  j=0;
  for(i=0;i<m;i++){
    a[j++]=a[i];
    if((a[i]-x) > rgs)j--;
  }
  if(m!=j && j>2)goto l10;
/* get mean value */
  x=0.;
  for(i=0;i<m;i++)x+=a[i]; 
  *mean= x/m;
}
	
inqh(f1,n1,n2)
char f1[];
int *n1,*n2;
{
  int k,ipos;
  FILE *fp;
  k=nindex(f1,".");
  if(k==-1)strcat(f1,".fit");
  fp=fopen(f1,"rb"); if(fp==0){ printf("%s not found!\n",f1); exit(0); }
  fread(head,80,72,fp); fclose(fp);
  sscanf(&head[3][21],"%d",n1); 	/* &*n1 == n1 */
  sscanf(&head[4][21],"%d",n2); 
  return(1);
}

sup_median(a,nn,medi)
float *a,*medi; int nn;
{
  float x; int i,j;
  for(i=0;i<nn-1;i++)for(j=i+1;j<nn;j++)if( *(a+i) > *(a+j)){
    x= *(a+i); *(a+i) = *(a+j); *(a+j)=x;
  }
  i=nn/2;
  *medi = (i+i==nn) ? (*(a+i) + *(a+i-1))*0.5 : *(a+i);
}
